"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable react/no-array-index-key */
const react_1 = __importDefault(require("react"));
const hooks_1 = require("../hooks");
function translation(position, width, height, margin) {
    switch (position) {
        case 'right': {
            return [width - (margin.right || 0) + 16, height / 2];
        }
        case 'left': {
            return [(margin.left || 0) - 130, height / 2];
        }
        default: {
            throw new Error(`Position ${JSON.stringify(position)} unknown`);
        }
    }
}
function Legend({ position }) {
    const { labels, margin, height, width, colorScaler } = hooks_1.usePlotContext();
    const [x, y] = translation(position, width, height, margin);
    return (react_1.default.createElement("g", { transform: `translate(${x}, ${y})` }, labels === null || labels === void 0 ? void 0 :
        labels.map((text, index) => (react_1.default.createElement("circle", { key: `circle-${text}-${index}`, cx: "0", cy: `${index + 1}em`, r: "0.25em", fill: colorScaler(text) }))), labels === null || labels === void 0 ? void 0 :
        labels.map((text, index) => (react_1.default.createElement("text", { key: `text-${text}-${index}`, x: "0.75em", y: `${index + 1.25}em` }, text)))));
}
exports.default = Legend;
